import React from "react";

type Props = {
    segment: {
        id: number
    }
    className?: string
    onClick: (id: number) => void
}

export default function SegmentRemoveBtn({ segment, className, onClick }: Props) {
    function onHandlerClick() {
        onClick(segment.id)
    }

    return (
        <button className={className} type={`button`} onClick={onHandlerClick}>
            <span className="dashicons dashicons-trash"></span>
        </button>
    )
}