import React from "react";
import * as style from "./SegmentSwitch.module.css";

export default function SegmentSwitch({ label_first = 'Выбрать', active, onChange }) {
    function onClick(event) {
        let value = event.target.dataset.value;
        if (active !== value) {
            onChange(value)
        }
    }

    return <div className={style.root}>
        <button className={`${style.btn} ${style.left} ${active === '1' ? style.active : ''}`}
                data-value="1"
                onClick={onClick}
                type="button">{label_first}
        </button>
        <button className={`${style.btn} ${style.right} ${active === '2' ? style.active : ''}`}
                data-value="2"
                onClick={onClick}
                type="button">Сегмент
        </button>
    </div>
}