import React, { useContext } from "react";
import { Context } from "../../state/state";

export default function SelectSegment({value, onChange}) {
    const { state: { ssr } } = useContext(Context)
    return <div style={{ marginBottom: '10px' }}>
        <label htmlFor="sourceSegment" style={{ display: 'inline-block', marginBottom: '5px' }}>
            <span className="dashicons dashicons-admin-users"></span> Сегмент
        </label>
        <div>
            <select name="segment"
                    value={value}
                    onChange={onChange}
                    id="sourceSegment" style={{ width: '100%', maxWidth: '100%' }}>
                <option value="">Выберите сегмент</option>
                {ssr.segments.map(segment =>
                    <option key={segment.id} value={segment.id}>{segment.name}</option>
                )}
            </select>
        </div>
    </div>
}