import React, { MouseEventHandler, ReactNode } from "react";

type SuccessNoticeProps = {
    children?: ReactNode
    onClose?: MouseEventHandler<HTMLButtonElement>
}

export default function SuccessNotice(props): React.FC {
    return <div style={{ marginLeft: 0, marginRight: 0 }}
                className={`notice notice-success is-dismissible`}>
        <p>{props.children}</p>
        <button type="button" className="notice-dismiss" onClick={props.onClose}>
            <span className="screen-reader-text">Скрыть это уведомление.</span>
        </button>
    </div>
}