import * as style from './Tabs.module.css';
import { useContext } from "react";
import { Context } from "../../state/state";

export default function Tabs() {
    const { state: { activeTab }, actions: { toggleTab } } = useContext(Context)

    function onClick(event) {
        toggleTab(event.target.dataset.tab)
    }

    return <ul className={style.tabs}>
        <li>
            <Tab name="sources" title="Источники" activeTab={activeTab} onClick={onClick}/>
        </li>
        <li>
            <Tab name="courses" title="Курсы" activeTab={activeTab} onClick={onClick}/>
        </li>
        <li>
            <Tab name="sales" title="Продажи" activeTab={activeTab} onClick={onClick}/>
        </li>
        <li>
            <Tab name="expiring" title="Истекающие" activeTab={activeTab} onClick={onClick}/>
        </li>
        <li>
            <Tab name="segments" title="Сегменты" activeTab={activeTab} onClick={onClick}/>
        </li>
    </ul>
}

function Tab({ onClick, activeTab, name, title }) {
    return <button type="button" data-tab={name}
                   onClick={onClick}
                   className={`${style.tab}${activeTab === name ? ' ' + style.tabActive : ''}`}>
        {title}
    </button>
}
