export default class CoursesEvents {
    private readonly dispatch: any;

    constructor(dispatch) {
        this.dispatch = dispatch
        this.onFetching = this.onFetching.bind(this)
        this.onFetched = this.onFetched.bind(this)
        this.levelsChanged = this.levelsChanged.bind(this)
        this.dateFromChanged = this.dateFromChanged.bind(this)
        this.dateToChanged = this.dateToChanged.bind(this)
        this.courseChanged = this.courseChanged.bind(this)
        this.switchedSegmentTab = this.switchedSegmentTab.bind(this)
        this.segmentChange = this.segmentChange.bind(this)
        this.onWarning = this.onWarning.bind(this)
        this.onError = this.onError.bind(this)
        this.onEnd = this.onEnd.bind(this)
    }

    onFetching() {
        this.dispatch({ type: 'courses.onFetching' });
    }

    onFetched(data) {
        this.dispatch({ type: 'courses.onFetched', payload: data });
    }

    onEnd() {
        this.dispatch({ type: 'courses.onEnd' });
    }

    levelsChanged(val) {
        this.dispatch({ type: 'courses.levelsChanged', payload: val });
    }

    dateFromChanged(val) {
        this.dispatch({ type: 'courses.dateFromChanged', payload: val });
    }

    dateToChanged(val) {
        this.dispatch({ type: 'courses.dateToChanged', payload: val });
    }

    courseChanged(event) {
        this.dispatch({ type: 'courses.courseChanged', payload: event.target.value });
    }

    switchedSegmentTab(value) {
        this.dispatch({ type: 'courses.switchedSegmentTab', payload: value });
    }

    segmentChange(event) {
        this.dispatch({ type: 'courses.segmentChange', payload: event.target.value });
    }

    onWarning(message) {
        this.dispatch({ type: 'courses.onWarning', payload: message });
    }

    onError(message) {
        this.dispatch({ type: 'courses.onError', payload: message });
    }
}