export default class ExpiringEvents {
    private readonly dispatch: any;

    constructor(dispatch) {
        this.dispatch = dispatch
        this.warningChanged = this.warningChanged.bind(this)
        this.itemsFetching = this.itemsFetching.bind(this)
        this.itemsFetched = this.itemsFetched.bind(this)
        this.dateToChanged = this.dateToChanged.bind(this)
        this.dateFromChanged = this.dateFromChanged.bind(this)
        this.levelChanged = this.levelChanged.bind(this)
        this.switchedSegmentTab = this.switchedSegmentTab.bind(this)
        this.segmentChange = this.segmentChange.bind(this)
    }

    warningChanged(message) {
        this.dispatch({ type: 'expiring.warningChanged', payload: message });
    }

    itemsFetching() {
        this.dispatch({ type: 'expiring.itemsFetching' });
    }

    itemsFetched(data) {
        this.dispatch({ type: 'expiring.itemsFetched', payload: data });
    }

    dateToChanged(date) {
        this.dispatch({ type: 'expiring.dateToChanged', payload: date });
    }

    dateFromChanged(date) {
        this.dispatch({ type: 'expiring.dateFromChanged', payload: date });
    }

    levelChanged(event) {
        this.dispatch({ type: 'expiring.levelChanged', payload: event.target.value });
    }

    switchedSegmentTab(value) {
        this.dispatch({ type: 'expiring.switchedSegmentTab', payload: value });
    }

    segmentChange(event) {
        this.dispatch({ type: 'expiring.segmentChange', payload: event.target.value });
    }
}