import { SsrProps } from "../state/models/SsrProps";

export default class SalesEvents {
    private readonly dispatch: any;
    private readonly props: any;

    constructor(dispatch, props: SsrProps) {
        this.dispatch = dispatch
        this.props = props
        this.onFetching = this.onFetching.bind(this)
        this.warningChanged = this.warningChanged.bind(this)
        this.onFetched = this.onFetched.bind(this)
        this.levelsChanged = this.levelsChanged.bind(this)
        this.dateFromChanged = this.dateFromChanged.bind(this)
        this.dateToChanged = this.dateToChanged.bind(this)
        this.levelChanged = this.levelChanged.bind(this)
        this.switchedSegmentTab = this.switchedSegmentTab.bind(this)
        this.segmentChange = this.segmentChange.bind(this)
    }

    onFetching() {
        this.dispatch({ type: 'sales.onFetching' });
    }

    warningChanged(message) {
        this.dispatch({ type: 'sales.warningChanged', payload: message });
    }

    onFetched(val) {
        this.dispatch({ type: 'sales.onFetched', payload: val });
    }

    levelsChanged(val) {
        this.dispatch({ type: 'sales.levelsChanged', payload: { val, all_levels: this.props.levels } });
    }

    dateFromChanged(val) {
        this.dispatch({ type: 'sales.dateFromChanged', payload: val });
    }

    dateToChanged(val) {
        this.dispatch({ type: 'sales.dateToChanged', payload: val });
    }

    levelChanged(event) {
        this.dispatch({ type: 'sales.levelChanged', payload: event.target.value });
    }

    switchedSegmentTab(value) {
        this.dispatch({ type: 'sales.switchedSegmentTab', payload: value });
    }

    segmentChange(event) {
        this.dispatch({ type: 'sales.segmentChange', payload: event.target.value });
    }
}