import { SsrProps } from "../state/models/SsrProps";

export default class SalesEvents {
    private readonly dispatch: any;
    private readonly props: any;

    constructor(dispatch, props: SsrProps) {
        this.dispatch = dispatch
        this.props = props
        this.onClickSegmentDownload = this.onClickSegmentDownload.bind(this)
        this.closeSegmentPopup = this.closeSegmentPopup.bind(this)
        this.saving = this.saving.bind(this)
        this.saved = this.saved.bind(this)
        this.savingComplete = this.savingComplete.bind(this)
        this.onError = this.onError.bind(this)
        this.changeName = this.changeName.bind(this)
        this.changeDescription = this.changeDescription.bind(this)
        this.onValidation = this.onValidation.bind(this)
        this.closeSuccess = this.closeSuccess.bind(this)
    }

    onClickSegmentDownload(value) {
        this.dispatch({ type: 'onClickSegment', payload: value })
    }

    closeSegmentPopup(value) {
        this.dispatch({ type: 'closeSegmentPopup' })
    }

    changeName(event) {
        this.dispatch({ type: 'segment:changeName', payload: event.target.value })
    }

    changeDescription(event) {
        this.dispatch({ type: 'segment:changeDescription', payload: event.target.value })
    }

    saving(value) {
        this.dispatch({ type: 'segment:saving' })
    }

    saved(data) {
        this.dispatch({ type: 'segment:saved', payload: data })
    }

    savingComplete() {
        this.dispatch({ type: 'segment:complete' })
    }

    onError(message) {
        this.dispatch({ type: 'segment:error', payload: message })
    }

    onValidation() {
        this.dispatch({ type: 'segment:validation' })
    }

    closeSuccess() {
        this.dispatch({ type: 'segment:closeSuccess' })
    }
}
