import { SsrProps } from "../state/models/SsrProps";

export default class SegmentTableEvents {
    private readonly dispatch: any;
    private readonly props: any;

    constructor(dispatch, props: SsrProps) {
        this.dispatch = dispatch
        this.props = props
        this.blocked = this.blocked.bind(this)
        this.onCompleted = this.onCompleted.bind(this)
        this.onCloseSuccessNotice = this.onCloseSuccessNotice.bind(this)
        this.onFailed = this.onFailed.bind(this)
        this.onRemoveSegment = this.onRemoveSegment.bind(this)
    }

    public blocked(state) {
        this.dispatch({ type: 'segmentTable.blocked', payload: state })
    }

    public onCompleted() {
        this.dispatch({ type: 'segmentTable.completed' })
    }

    public onCloseSuccessNotice() {
        this.dispatch({ type: 'segmentTable.successNoticeClosed' })
    }

    public onFailed(message) {
        this.dispatch({ type: 'segmentTable.failed', payload: message })
    }

    public onRemoveSegment(id) {
        this.dispatch({ type: 'segmentTable.remove', payload: id })
    }
}
