export default class Sources {
    private readonly dispatch: any;

    constructor(dispatch) {
        this.dispatch = dispatch
        this.warningChanged = this.warningChanged.bind(this)
        this.onFetching = this.onFetching.bind(this)
        this.onFetched = this.onFetched.bind(this)
        this.startChanged = this.startChanged.bind(this)
        this.endChanged = this.endChanged.bind(this)
        this.sourceChanged = this.sourceChanged.bind(this)
        this.termsChanged = this.termsChanged.bind(this)
        this.durationChanged = this.durationChanged.bind(this)
        this.utmSourceChanged = this.utmSourceChanged.bind(this)
        this.utmMediumChanged = this.utmMediumChanged.bind(this)
        this.utmCampaignChanged = this.utmCampaignChanged.bind(this)
        this.utmIdChanged = this.utmIdChanged.bind(this)
        this.utmTermChanged = this.utmTermChanged.bind(this)
        this.utmContentChanged = this.utmContentChanged.bind(this)
    }

    warningChanged(message) {
        this.dispatch({ type: 'warningChanged', payload: message });
    }

    onFetching() {
        this.dispatch({ type: 'onFetching' });
    }

    onFetched(data) {
        this.dispatch({ type: 'sources:onFetched', payload: data });
    }

    startChanged(date) {
        this.dispatch({ type: 'startChanged', payload: date });
    }

    endChanged(date) {
        this.dispatch({ type: 'endChanged', payload: date });
    }

    sourceChanged(val) {
        this.dispatch({ type: 'sourceChanged', payload: val });
    }

    termsChanged(val) {
        this.dispatch({ type: 'termsChanged', payload: val });
    }

    durationChanged(event) {
        this.dispatch({ type: 'durationChanged', payload: event.target.value });
    }

    utmSourceChanged(value) {
        this.dispatch({ type: 'utmSourceChanged', payload: value });
    }

    utmMediumChanged(value) {
        this.dispatch({ type: 'utmMediumChanged', payload: value });
    }

    utmCampaignChanged(value) {
        this.dispatch({ type: 'utmCampaignChanged', payload: value });
    }

    utmIdChanged(value) {
        this.dispatch({ type: 'utmIdChanged', payload: value });
    }

    utmTermChanged(value) {
        this.dispatch({ type: 'utmTermChanged', payload: value });
    }

    utmContentChanged(value) {
        this.dispatch({ type: 'utmContentChanged', payload: value });
    }
}
