import { StateWithoutSsr } from "./models/AppState";

export const initialState: StateWithoutSsr = {
    activeTab: "sources",
    segment: null,
    segmentError: '',
    segmentSuccess: false,
    segmentSaving: false,
    segmentPopup: false,
    nameInvalid: false,
    descriptionInvalid: false,
    sources: {
        start: new Date(),
        end: new Date(),
        source: ['all'],
        terms: ['all'],
        duration: 'all',
        utm_source: '',
        utm_medium: '',
        utm_campaign: '',
        utm_id: '',
        utm_term: '',
        utm_content: '',
        warning: '',
        isFetching: false,
        items: [],
        total_segment: null,
        total: 0,
    },
    sales: {
        levels: [],
        dateFrom: new Date(),
        dateTo: new Date(),
        level: '',
        sale: 0,
        no_sale: 0,
        sale_segment: null,
        no_sale_segment: null,
        warning: '',
        isFetching: false,
        segment_tab: '1',
        segment: '',
        is_segment: false,
    },
    expiring: {
        dateFrom: new Date(),
        dateTo: new Date(),
        level: '',
        warning: '',
        disabled: false,
        items: [],
        segment: '',
        segment_tab: '1',
        is_segment: false,
        total_segment: null
    },
    courses: {
        course: "",
        levels: ['all'],
        dateFrom: new Date(),
        dateTo: new Date(),
        items: [],
        isFetching: false,
        segment_tab: '1',
        segment: '',
        is_segment: false,
        warning: '',
        error: '',
    },
    segmentTable: {
        blocking: false,
        completed: false,
        error: ''
    }
}
