import { SourceState } from "./SourceState";
import { Expiring } from "./Expiring";
import { Sales } from "./Sales";
import { Courses } from "./Courses";
import { Segment } from "./Segment";
import { SsrProps } from "./SsrProps";
import { SegmentTable } from "./SegmentTable";

export type WithSsr = {
    ssr: SsrProps
}

export type StateWithoutSsr = {
    activeTab: 'courses' | 'sales' | 'sources' | 'expiring' | 'segments'
    segment: Segment
    segmentError: string
    nameInvalid: boolean
    descriptionInvalid: boolean
    segmentSuccess: boolean
    segmentSaving: boolean
    segmentPopup: boolean
    sources: SourceState
    sales: Sales
    expiring: Expiring
    courses: Courses
    segmentTable: SegmentTable
}

export type AppState = StateWithoutSsr & WithSsr