<?php

namespace Mbl\Analytics;

class Core
{
    public function __construct()
    {
    }

    public function run()
    {
        add_action('init', [$this, 'init']);
        require_once MBAN_PLUGIN_PATH . '/admin/rest.php';
    }

    public function init()
    {
        if ($this->_pluginEnabled()) {
            require_once MBAN_PLUGIN_PATH . '/admin/main.php';
        } elseif (is_admin()) {
            add_action('admin_notices', array($this, 'notActiveNotice'));
        }
    }

    public function install()
    {
        defined('WP_MEMBERSHIP_VERSION') || exit;
    }

    public function notActiveNotice(): void
    {
        $class = 'notice notice-error';
        $message = __('МОДУЛЬ АНАЛИТИКИ не активирован!', 'mbl_admin');
        if (!defined('WP_MEMBERSHIP_VERSION')) {
            $message .= ' ' . __('Не установлен плагин MEMBERLUX.', 'mbl_admin');
        } elseif (version_compare(WP_MEMBERSHIP_VERSION, '2.56', '<')) {
            $message .= ' ' . __('Устаревшая версия MEMBERLUX.', 'mbl_admin');
        } elseif (!$this->_pluginKeyActive()) {
            $message .= ' ' . __('Ключ не активирован.', 'mbl_admin');
        }
        printf('<div class="%1$s"><p>%2$s</p></div>', esc_attr($class), esc_html($message));
    }

    private function _pluginEnabled(): bool
    {
        return defined('WP_MEMBERSHIP_VERSION')
            && !version_compare(get_option('wpm_version'), '2.56', '<')
            && $this->_pluginKeyActive();
    }

    private function _pluginKeyActive(): bool
    {
        $activeKeys = wpm_array_pluck(wpm_array_get(wpm_get_key_data(), 'keys.active', array()), 'type');

        if (count(wpm_array_filter($activeKeys, 'fullpackaccess'))) {
            return true;
        }

        return (bool)count(wpm_array_filter($activeKeys, 'analytics'));
    }
}
