<?php

namespace Mbl\Analytics;

use Exception;

class CourseStatRoute
{
    /**
     * @throws Exception
     */
    public function response(): array
    {
        $post = json_decode(file_get_contents('php://input'), true);
        $course_id = (int)$post['course'];
        $course = new Course($course_id);
        $coursesStat = new CoursesStat($course);

        if (isset($post['segment'])) {
            $segmentData = (new Segments())->byId((int)$post['segment']);
            $segment = new Segment($segmentData['type'], $segmentData['params']);
            $result = $coursesStat->toArray($segment->selection(), new SDateRange($post['dateFrom'], $post['dateTo']));
        } else {
            $stat = new CoursesStateSegmented($course_id, $coursesStat);
            $result = $stat->toArray($post['levels'], $post['dateFrom'], $post['dateTo']);
        }

        return [
            'ok' => true,
            'items' => $result,
            'segment' => $segmentData ?? [],
        ];
    }
}
