<?php

namespace Mbl\Analytics;

class CoursesStateSegmented
{
    private int $course_id;
    private CoursesStat $coursesStat;

    /**
     * @param int $course_id
     * @param CoursesStat $coursesStat
     */
    public function __construct( int $course_id, CoursesStat $coursesStat )
    {
        $this->course_id = $course_id;
        $this->coursesStat = $coursesStat;
    }


    public function toArray( $term_ids, $dateFrom, $dateTo ): array
    {
        $range = new SDateRange( $dateFrom, $dateTo );
        $userSelection = new UserHasAccessByCourse( new Course( $this->course_id ), $term_ids, $range );

        $data = $this->coursesStat->toArray( $userSelection, $range );
        foreach ( $data as $key => $group ) {
            $data[$key]['segment'] = [
                'type' => 'courses',
                'params' => [
                    'course' => $this->course_id,
                    'levels' => $term_ids,
                    'from' => $dateFrom,
                    'to' => $dateTo,
                    'lesson' => $group['id'],
                ]
            ];
        }

        return $data;
    }
}
