<?php

namespace Mbl\Analytics;

use Exception;

class Expiring
{
    private int $term_id;

    /**
     * @param int $term_id
     */
    public function __construct( int $term_id )
    {
        $this->term_id = $term_id;
    }

    /**
     * @param $from
     * @param $to
     * @param Segment | null $segment
     * @return array
     * @throws Exception
     */
    public function toArray( $from, $to, Segment $segment = null ): array
    {
        global $wpdb;
        $where = '';
        if ( $segment ) {
            $where = " AND tk.user_id IN(" . $segment->selection()->idsRequest( 'exp' ) . ")";
        }

        $selection = new UserExpiringAccess( $this->term_id, new SDateRange( $from, $to ) );

        $result = $wpdb->get_results(
            "SELECT COUNT(DISTINCT tk.user_id) as count, tk.`duration`, tk.`units`"
            . PHP_EOL . $selection->request() . $where
            . PHP_EOL . " GROUP BY tk.`duration`, tk.`units`"
            . PHP_EOL . " ORDER BY tk.`units`, tk.`duration`",
            ARRAY_A
        );

        return $result ?: [];
    }
}
