<?php

namespace Mbl\Analytics;

use Exception;

class ExpiringRoute
{
    /**
     * @throws Exception
     */
    public function response(): array
    {
        global $wpdb;
        $post = json_decode(file_get_contents('php://input'), true);
        $level = (int)$post['level'];
        $expiring = new Expiring($level);
        $from = date('Y-m-d', strtotime($post['dateFrom']));
        $to = date('Y-m-d', strtotime($post['dateTo']));
        if (!isset($post['segment'])) {
            $stat = new ExpiringSegmented($level, $expiring);
        } else {
            $stat = $expiring;
        }

        return [
            'ok' => true,
            'segment' => [
                'type' => 'expiring',
                'params' => [
                    'level' => $level,
                    'from' => $from,
                    'to' => $to,
                ]
            ],
            'items' => $stat->toArray($from, $to),
            //'log' => preg_replace("/\n/", '', preg_replace("/\r\n/", '', $wpdb->last_query)),
        ];
    }
}
