<?php

namespace Mbl\Analytics;

class ExpiringSegmented
{
    private int $term_id;
    private Expiring $expiring;

    /**
     * @param int $term_id
     * @param Expiring $expiring
     */
    public function __construct(int $term_id, Expiring $expiring)
    {
        $this->term_id = $term_id;
        $this->expiring = $expiring;
    }

    public function toArray($from, $to)
    {
        $data = $this->expiring->toArray($from, $to);
        foreach ($data as $key => $item) {
            $data[$key]['segment'] = [
                'type' => 'expiring',
                'params' => [
                    'level' => $this->term_id,
                    'from' => $from,
                    'to' => $to,
                    'duration' => $item['duration'],
                    'units' => $item['units'],
                ]
            ];
        }

        return $data;
    }
}
