<?php

namespace Mbl\Analytics\Filter;

use Mbl\Analytics\DateRange;

class CnDateAvailability implements Condition
{
    private DateRange $range;

    /**
     * @param DateRange $range
     */
    public function __construct(DateRange $range)
    {
        $this->range = $range;
    }

    function where(string $tbAlias): string
    {
        return sprintf(
            "(
                        (%s.date_end >= '%s' AND %s.date_start <= '%s' AND %s.is_unlimited != 1)
                        OR (%s.date_start <= '%s' AND %s.is_unlimited = 1)
                    )",
            $tbAlias,
            $this->range->from()->format('Y-m-d'),
            $tbAlias,
            $this->range->to()->format('Y-m-d'),
            $tbAlias,
            $tbAlias,
            $this->range->to()->format('Y-m-d'),
            $tbAlias,
        );
    }
}
