<?php

namespace Mbl\Analytics\Filter;

use Mbl\Analytics\DateRange;

class CnDateStartBetween implements Condition
{
    private DateRange $range;

    /**
     * @param DateRange $range
     */
    public function __construct(DateRange $range)
    {
        $this->range = $range;
    }

    function where($tbAlias): string
    {
        return sprintf(
            "%s.date_start BETWEEN '%s' AND '%s'",
            $tbAlias,
            $this->range->from()->format('Y-m-d'),
            $this->range->to()->format('Y-m-d')
        );
    }
}
