<?php

namespace Mbl\Analytics\Filter;

class CnDurationType implements Condition
{
    private Condition $filter;

    public function __construct($duration, $units = null)
    {
        if ($duration === 'limited') {
            $this->filter = new CnLimitedDuration();
        } elseif ($duration === 'unlimited') {
            $this->filter = new CnUnlimitedDuration();
        } elseif (!is_null($units) && is_numeric($duration)) {
            $this->filter = new CnSpecifiedDuration((int)$duration, $units);
        } else {
            $this->filter = new CnAnyDurationType();
        }
    }

    public function where($tbAlias): string
    {
        return $this->filter->where($tbAlias);
    }
}
