<?php

namespace Mbl\Analytics\Filter;

class STermKeysFrom implements TermKeysFrom
{
    private TableName $tbAlias;
    private string $tb;

    /**
     * @param TableName $tbAlias
     * @param string $tb
     */
    public function __construct(TableName $tbAlias, string $tb = 'memberlux_term_keys')
    {
        $this->tbAlias = $tbAlias;
        $this->tb = $tb;
    }

    public function clause(): string
    {
        global $wpdb;
        return $this->tbAlias->withAlias("FROM `$wpdb->prefix$this->tb` AS tk", 'tk');
    }

    public function withAlias(string $clause, string $tb): string
    {
        return $this->tbAlias->withAlias($clause, $tb);
    }
}
