<?php

namespace Mbl\Analytics\Filter;

class SimpleSelectorFilters implements SelectorFilters
{
    /**
     * @var Condition[]
     */
    private array $filters;

    /**
     * @param Condition[] $conditions
     */
    public function __construct(array $conditions)
    {
        $this->filters = $conditions;
    }

    public function toWhere(): string
    {
        $reduce = function ($carry, Condition $filter) {
            return ($carry === '' ? '' : ($carry . ' AND ')) . $filter->where('%s');
        };

        return array_reduce($this->filters, $reduce, '');
    }
}
