<?php

namespace Mbl\Analytics\Filter;

class TermKeysFromWithMeta implements TermKeysFrom
{
    private TermKeysFrom $origin;
    private TableName $tbAlias;
    private string $tb;

    /**
     * @param TermKeysFrom $origin
     * @param TableName $tbAlias
     * @param string $tb
     */
    public function __construct(TermKeysFrom $origin, TableName $tbAlias, string $tb = 'memberlux_keys_meta')
    {
        $this->origin = $origin;
        $this->tbAlias = $tbAlias;
        $this->tb = $tb;
    }

    public function clause(): string
    {
        global $wpdb;
        return $this->origin->clause() . PHP_EOL . $this->origin->withAlias(
                $this->tbAlias->withAlias(
                    "JOIN `$wpdb->prefix$this->tb` AS km ON km.key_id = tk.id",
                    'km'
                ),
                'tk'
            );
    }

    public function withAlias(string $clause, string $tb): string
    {
        return $this->origin->withAlias($clause, $tb);
    }
}
