<?php

namespace Mbl\Analytics\Filter;

class TermKeysFromWithUser implements TermKeysFrom
{
    private TermKeysFrom $origin;
    private TableName $tbAlias;
    private string $table;

    /**
     * @param TermKeysFrom $origin
     * @param TableName $tbAlias
     * @param string $table
     */
    public function __construct(TermKeysFrom $origin, TableName $tbAlias, string $table = 'usermeta')
    {
        $this->origin = $origin;
        $this->tbAlias = $tbAlias;
        $this->table = $table;
    }


    public function clause(): string
    {
        global $wpdb;
        return $this->origin->clause() . PHP_EOL . $this->origin->withAlias(
                $this->tbAlias->withAlias(
                    "JOIN `$wpdb->prefix$this->table` AS um"
                    . " ON um.user_id = tk.user_id AND um.meta_key = '{$wpdb->prefix}capabilities'",
                    'um'
                ),
                'tk'
            );
    }

    public function withAlias(string $clause, string $tb): string
    {
        return $this->origin->withAlias($clause, $tb);
    }
}
