<?php

namespace Mbl\Analytics;

class LessonData
{
    private array $userLesson;
    private Course $course;

    /**
     * @param array $userLesson
     * @param Course $course
     */
    public function __construct( array $userLesson, Course $course )
    {
        $this->userLesson = $userLesson;
        $this->course = $course;
    }

    public function isVisible(): bool
    {
        return $this->userLesson['isVisible'];
    }

    public function isAvailable(): bool
    {
        if ( !$this->userLesson['isAccess'] ) {
            return false;
        }

        if ( $this->course->is_autotraining() ) {
            return $this->userLesson['index'] === 0 || $this->userLesson['prevPassed'];
        } else {
            return true;
        }
    }

    public function homeworkIsSent(): bool
    {
        return !is_null( $this->userLesson['responseStatus'] );
    }

    public function homeworkIsOpened(): bool
    {
        return $this->userLesson['responseStatus'] === 'opened';
    }

    public function homeworkIsApproved(): bool
    {
        return $this->userLesson['responseStatus'] === 'accepted' || $this->userLesson['responseStatus'] === 'approved';
    }

    public function homeworkIsRejected(): bool
    {
        return $this->userLesson['responseStatus'] === 'rejected';
    }

    public function isOpened(): bool
    {
        return $this->userLesson['opened'];
    }

    public function prevIsPassed(): bool
    {
        return $this->userLesson['prevPassed'];
    }
}
