<?php

namespace Mbl\Analytics;

use Exception;
use WP_REST_Request;

class PreSegmentsRoute
{
    public function __construct()
    {
    }

    public function create(): array
    {
        $post = json_decode(file_get_contents('php://input'), true);
        $segments = new Segments();
        $segmentData = json_decode(base64_decode($post['segment']), true);
        $segments->create($post['name'], $post['description'], $segmentData['type'], $segmentData['params']);
        global $wpdb;

        return ['ok' => true, 'redirect' => admin_url('users.php?page=mbl_users_export&viewSegment=') . $wpdb->insert_id];
    }

    public function edit(WP_REST_Request $request): array
    {
        $post = json_decode(file_get_contents('php://input'), true);
        $id = absint($request->get_param('id'));
        $segments = new Segments();
        $segments->edit($id, $post);

        return ['ok' => true];
    }

    public function segment(WP_REST_Request $request): array
    {
        $id = absint($request->get_param('id'));
        $segments = new Segments();
        $segmentData = $segments->byId($id);
        $segment = new Segment($segmentData['type'], $segmentData['params']);
        $segmentUsers = new SegmentsUsers($segment);
        $data = $segmentUsers->toArray();
        $count = count($data);

        return array_merge($segmentData, [
            'users' => $data, 'count' => $count
        ]);
    }

    /**
     * @throws Exception
     */
    public function view(): array
    {
        $segmentData = json_decode(base64_decode($_GET['viewUsers']), true);
        $segment = new Segment($segmentData['type'], $segmentData['params']);
        $segmentUsers = new SegmentsUsers($segment);
        $data = $segmentUsers->toArray();
        $count = count($data);

        return ['ok' => true, 'data' => $data, 'count' => $count ];
    }
}
