<?php

namespace Mbl\Analytics;

use DateTime;
use Exception;

class SDateRange implements DateRange
{
    /**
     * @var string | DateTime
     */
    private $from;
    /**
     * @var string | DateTime
     */
    private $to;

    public function __construct($from, $to)
    {
        if ($from instanceof DateTime) {
            $this->from = $from;
        } else {
            try {
                $this->from = new DateTime($from, wp_timezone());
            } catch (Exception $e) {
                $this->from = new DateTime('now');
            }
        }
        if ($to instanceof DateTime) {
            $this->to = $to;
        } else {
            try {
                $this->to = new DateTime($to, wp_timezone());
            } catch (Exception $e) {
                $this->to = new DateTime('now');
            }
        }
    }


    public function from(): DateTime
    {
        return $this->from;
    }

    public function to(): DateTime
    {
        return $this->to;
    }
}
