<?php

namespace Mbl\Analytics;

use Exception;

class SalesRoute
{
    /**
     * @throws Exception
     */
    public function response(): array
    {
        $post = json_decode(file_get_contents('php://input'), true);
        $level_id = (int)$post['level'];
        if (isset($post['segment'])) {
            $segment = (new Segments())->byId((int)$post['segment']);
            $stat = new SalesStatBySegment($segment);
            $data = $stat->toArray($level_id);
        } else {
            $levels = array_map(fn($term_id) => (int)$term_id, $post['levels']);
            $stat = new SalesStat();
            $data = $stat->toArray($level_id, $levels, new SDateRange($post['dateFrom'], $post['dateTo']));
        }

        return [
            'ok' => true,
            'data' => $data,
        ];
    }
}
