<?php

namespace Mbl\Analytics;

class SalesStat
{
    public function toArray( int $level_id, array $levels, DateRange $range ): array
    {
        global $wpdb;
        $userHasAccessPurchased = new UserHasAccessPurchased( $level_id, $levels, $range );
        $sale = $wpdb->get_var( "SELECT COUNT(DISTINCT tk.user_id) {$userHasAccessPurchased->request()}" );
        $userHasAccessNotPurchased = new UserHasAccessNotPurchased( $level_id, $levels, $range );
        $no_sale = $wpdb->get_var( "SELECT COUNT(DISTINCT tk.user_id) {$userHasAccessNotPurchased->request()}" );


        return [
            'sale' => intval( $sale ),
            'sale_segment' => [
                'type' => 'sales',
                'params' => [
                    'levels' => $levels,
                    'from' => $range->from()->format( 'Y-m-d' ),
                    'to' => $range->to()->format( 'Y-m-d' ),
                    'level' => $level_id,
                    'sale' => true
                ]
            ],
            'no_sale' => intval( $no_sale ),
            'no_sale_segment' => [
                'type' => 'sales',
                'params' => [
                    'levels' => $levels,
                    'from' => $range->from()->format( 'Y-m-d' ),
                    'to' => $range->to()->format( 'Y-m-d' ),
                    'level' => $level_id,
                    'sale' => false
                ]
            ],
        ];
    }
}
