<?php

namespace Mbl\Analytics;

use Exception;

class SalesStatBySegment
{
    private array $segmentData;

    /**
     * @param array $segment
     */
    public function __construct( array $segment )
    {
        $this->segmentData = $segment;
    }

    /**
     * @throws Exception
     */
    public function toArray( int $level_id): array
    {
        global $wpdb;
        $segment = new Segment($this->segmentData['type'], $this->segmentData['params']);
        $selection = $segment->selection();
        $range = new SDateRange($this->segmentData['params']['from'], $this->segmentData['params']['to']);

        $userGotAccess = new UserGotAccessDuringPeriod([$level_id], $range);
        $sale = $wpdb->get_var(
            "SELECT COUNT(DISTINCT tk.user_id) {$userGotAccess->request()}" .
            " AND tk.user_id IN (" . $selection->idsRequest('us_l') . ")"
        );
        $all = $wpdb->get_var("SELECT COUNT(DISTINCT tk.user_id) {$selection->request()}");


        return [
            'sale' => intval($sale),
            'no_sale' => intval($all - $sale),
        ];
    }
}
