<?php

namespace Mbl\Analytics;

class Segments
{
    private string $table;

    public function __construct()
    {
        global $wpdb;
        $this->table = "{$wpdb->prefix}memberlux_analytics_segments";
    }

    public function create($name, $description, $type, $params)
    {
        global $wpdb;
        $data = [
            'name' => $name,
            'description' => $description,
            'type' => $type,
            'params' => serialize($params),
        ];
        $wpdb->insert($this->table, $data);
    }

    public function edit($id, $data)
    {
        global $wpdb;
        $wpdb->update($this->table, $data, ['id' => $id]);
    }

    public function delete($id)
    {
        global $wpdb;
        $wpdb->delete($this->table, ['id' => $id]);
    }

    public function query($params = []): array
    {
        global $wpdb;
        return array_map(
            function ($row) {
                $row['params'] = unserialize($row['params']);
                return $row;
            },
            $wpdb->get_results("SELECT * FROM `$this->table`", ARRAY_A)
        );
    }

    public function byId(int $id): array
    {
        global $wpdb;
        $row = $wpdb->get_row("SELECT * FROM `$this->table` WHERE `id` = $id", ARRAY_A);
        $row['params'] = unserialize($row['params']);

        return $row;
    }
}
