<?php

namespace Mbl\Analytics;

use Exception;

class SegmentsUsers
{
    private Segment $segment;

    /**
     * @param Segment $segment
     */
    public function __construct(Segment $segment)
    {
        $this->segment = $segment;
    }

    /**
     * @throws Exception
     */
    public function toArray(): array
    {
        global $wpdb;
        $segment = $this->segment;

        $fields = "u.ID, u.user_login AS userName, u.user_email AS email";

        $users = $wpdb->get_results(
            "SELECT $fields FROM $wpdb->users AS u WHERE u.ID IN ({$segment->selection()->idsRequest()})",
            ARRAY_A
        );

        $metaKeys = ['first_name', 'last_name', 'surname', 'phone'];
        $metaKeysIn = implode(',', array_map(fn($key) => "'$key'", $metaKeys));
        $data = [];

        try {
            $usersMetaFields = $wpdb->get_results(
                "SELECT user_id, meta_key, meta_value FROM $wpdb->usermeta AS um
                WHERE um.user_id IN ({$segment->selection()->idsRequest()})
                  AND um.meta_key IN($metaKeysIn) AND meta_value != '' AND meta_value IS NOT NULL",
                ARRAY_A
            );

            $usersMetaFieldsByUserId = [];
            foreach ($usersMetaFields as $meta) {
                $usersMetaFieldsByUserId[$meta['user_id']][$meta['meta_key']] = $meta['meta_value'];
            }
            foreach ($users as $user) {
                $data[] = [
                    'ID' => $user['ID'],
                    'userName' => $user['userName'],
                    'userLink' => admin_url('user-edit.php') . '?' . http_build_query([
                        'user_id' => $user['ID']
                        ]),
                    'lastName' => $usersMetaFieldsByUserId[$user['ID']]['last_name'] ?? '',
                    'firstName' => $usersMetaFieldsByUserId[$user['ID']]['first_name'] ?? '',
                    'surname' => $usersMetaFieldsByUserId[$user['ID']]['surname'] ?? '',
                    'phone' => $usersMetaFieldsByUserId[$user['ID']]['phone'] ?? '',
                    'email' => $user['email']
                ];
            }
        } catch (Exception $e) {

        }

        return $data;
    }
}
