<?php

namespace Mbl\Analytics;

use Exception;
use WP_REST_Request;

class SourcesRoute
{

    /**
     * @param WP_REST_Request $request
     * @return array
     * @throws Exception
     */
    public function response(WP_REST_Request $request): array
    {
        /**
         * Structure of array:
         *
         * [
         *   'duration' => "limited", //'all' or 'limited' or 'unlimited'
         *   'start' => "2023-01-03T04:34:41.000Z",
         *   'end' => "2023-11-03T04:34:41.000Z",
         *   'source' => ["free_registration_form", "bulk_operations_reg", "profile_page_admin"],
         *      //'purchase' or 'free_item' or 'free_registration_form' or 'bulk_operations_reg'
         *      // or 'bulk_operations_add' or 'auto_registration' or 'activation_page'
         *      // or 'profile_page_self' or 'profile_page_admin' or 'after_auto_training_passed'
         *   'terms' => ["26", "27"], // ['all'] or string[],
         *   'utm_source' => 'google',
         *   'utm_medium' => 'cpc',
         *   'utm_campaign' => 'black_friday',
         *   'utm_id' => '2323',
         *   'utm_term' => 'social_media_tool',
         *   'utm_content' => 'video_ad'
         * ]
         */
        $params = $request->get_json_params();
        $statSegmented = new SourcesStatSegmented($params);

        return [
            'ok' => true,
            'data' => $statSegmented->toArray(),
        ];
    }
}
