<?php

namespace Mbl\Analytics;

class UserHasAccess implements UserSelection
{
    private array $levels;
    private DateRange $range;

    /**
     * @param int[] $levels
     * @param DateRange $range
     */
    public function __construct(array $levels, DateRange $range)
    {
        $this->levels = $levels;
        $this->range = $range;
    }

    public function request(string $tablePrefix = ''): string
    {
        global $wpdb;
        $prefix = $tablePrefix;
        $keysTb = "tk$tablePrefix";

        $levels_in = implode(', ', $this->levels);
        $levels_where = "$keysTb.term_id IN ($levels_in)";
        $duration_where = sprintf(
            "(
                        ($keysTb.date_end >= '%s' AND $keysTb.date_start <= '%s' AND $keysTb.is_unlimited != 1)
                        OR ($keysTb.date_start <= '%s' AND $keysTb.is_unlimited = 1)
                    )",
            $this->range->from()->format('Y-m-d'),
            $this->range->to()->format('Y-m-d'),
            $this->range->to()->format('Y-m-d'),
        );

        return "FROM `{$wpdb->prefix}memberlux_term_keys` AS $keysTb
        JOIN `{$wpdb->prefix}usermeta` AS um$prefix
            ON um$prefix.user_id = $keysTb.user_id AND  um$prefix.meta_key = '{$wpdb->prefix}capabilities'
        WHERE $levels_where AND $keysTb.is_banned != 1 AND $keysTb.key_type = 'wpm_term_keys' AND $duration_where
            AND um$prefix.meta_value LIKE '%customer%'
        ";
    }

    public function idsRequest(string $tablePrefix = ''): string
    {
        return "SELECT DISTINCT tk$tablePrefix.user_id {$this->request($tablePrefix)}";
    }
}
