<?php

namespace Mbl\Analytics;

class UserHasAccessByCourse implements UserSelection
{
    private Course $course;
    private array $levels;
    private SDateRange $range;
    private UserSelection $origin;

    /**
     * @param Course $course
     * @param array $levels
     * @param SDateRange $range
     */
    public function __construct(Course $course, array $levels, SDateRange $range)
    {
        $this->course = $course;
        $this->levels = $levels;
        $this->range = $range;

        if ($this->levels[0] === 'all') {
            $levels = array_map(fn($term) => $term->term_id, $this->course->levels());
        } else {
            $levels = array_map(fn($term_id) => (int)$term_id, $this->levels);
        }

        $this->origin = new UserHasAccess($levels, $this->range);
    }

    public function request(string $tablePrefix = ''): string
    {

        return $this->origin->request($tablePrefix);
    }

    public function idsRequest(string $tablePrefix = ''): string
    {
        return $this->origin->idsRequest($tablePrefix);
    }
}
